<?php

/*
 * @version $Id: thumbcreate.php 150 2013-06-12 16:20:53Z hi $
 *
 */

/*
  lb_gallery: a CMSimple Lightbox-Gallery-Plugin
  based on Michael Svarrers Gallery-Plugin, Verion 0.9

  @Version: 1.6.1@
  @Date: 2013-06-12@
  @Copyright: Holger Irmler - http://CMSimple.HolgerIrmler.de
  @License: see license.txt

 */

//if ((!function_exists('sv')) || (strlen($sl) !== 2) || eregi('thumbcreate.php', sv('PHP_SELF')))
//    die('Access denied');

function CreateThumb($dir, $file) {
    global $plugin_cf;
    $t = '';
    touch($dir . "thumb/tn_$file");
    $stst = $plugin_cf['gallery']['thumb_size'];
    $qual = $plugin_cf['gallery']['thumb_quality'];

    $size = GetImageSize($dir . $file);
    $w = $size[0];
    $h = $size[1];

    if (!$size) {
        $t .= tag('br') . "Gallery Error : Unable to getimagesize(" . $file . ")";
        return $t;
        exit;
    }

    $used_size = Round(($size[0] * $size[1] * $size['bits'] * $size['channels'] / 8 + Pow(2, 16)) * 1.65);
    // Check memory
    $memory_limit = ini_get('memory_limit');
    if ($memory_limit == "") {
        $memory_limit = $plugin_cf['gallery']['memory_limit'];
    }
//    if (ereg_i('([0-9]+)M', $memory_limit, $matches)) {
//        $memory_limit = $matches[1] * 1048576;
//    }

    $memory_limit = $memory_limit * 1024 * 1024;
    if ($used_size > $memory_limit) {
        $t .= tag('br') . "<div class='cmsimplecore_warning'>Fatal Error : Not enough memory ($memory_limit bytes) allocated to make thumbnail from $file, requires $used_size bytes</div>";
        return $t;
        exit;
    }
    if (!ini_get('safe_mode')) {
        set_time_limit(0);
    }

    $bigpic = imagecreatefromjpeg($dir . $file);

    if ((ereg_i("true", $plugin_cf['gallery']['thumb_crop'])) || (ereg_i("quadrate", $plugin_cf['gallery']['thumb_crop']))) {
        if ($w > $h) {
            $off_w = ($w - $h) / 2;
            $off_h = 0;
            $w = $h;
        } elseif ($h > $w) {
            $off_w = 0;
            $off_h = ($h - $w) / 2;
            $h = $w;
        } else {
            $off_w = 0;
            $off_h = 0;
        }
    } else {
        $off_w = 0;
        $off_h = 0;
    }

    if (ereg_i("height", $plugin_cf['gallery']['thumb_crop'])) {
        $x = $w / $h * $stst;
        $y = $h / $h * $stst;
    } elseif (ereg_i("width", $plugin_cf['gallery']['thumb_crop'])) {
        $x = $w / $w * $stst;
        $y = $h / $w * $stst;
    } else {
        if ($w >= $h) {
            $x = $w / $w * $stst;
            $y = $h / $w * $stst;
        }
        if ($h >= $w) {
            $x = $w / $h * $stst;
            $y = $h / $h * $stst;
        }
    }

    $smallpic = imageCreateTrueColor($x, $y);
    if (!$smallpic) {
        $smallpic = imageCreate($x, $y);
        ImageCopyResized($smallpic, $bigpic, 0, 0, $off_w, $off_h, $x, $y, $w, $h);
    } else {
        imagecopyresampled($smallpic, $bigpic, 0, 0, $off_w, $off_h, $x, $y, $w, $h);
    }
    ImageJPEG($smallpic, $dir . "thumb/tn_" . $file, $qual);
    ImageDestroy($smallpic);
    ImageDestroy($bigpic);

//    $old_umask = umask(0);
//    chmod($dir . "thumb/tn_" . $file, 0766);
//    umask($old_umask);

    if (!is_readable($dir . "thumb/tn_$file")) {
        $t .= tag('br') . "<b>Gallery plugin Error :</b> Creation of thumb failed, gallery script has no access to thumb file, check your permisions " . $dir . "thumb/tn_$file!";
    }
    return $t;
    exit;
}

function AddComment($dir, $pic, $name = '', $text = '') {
    global $pth, $plugin_cf, $plugin_tx, $sn, $su, $files, $title_array;
    if (!preg_match('/true/i', $plugin_cf['gallery']['show_comments']) 
            || preg_match('/true/i', $plugin_cf['gallery']['show_comments_closed'])) {
        header("Location: " . $sn . "?" . $su);
        exit;
    }
    $page = getvariable('page');
    $file = $files[$pic];
    $size = GetImageSize($dir . "thumb/tn_" . $file);
    $w = $size[0];
    $h = $size[1];
    $title = $title_array[$pic][0];
    $name = htmlspecialchars($name, ENT_QUOTES, $plugin_cf['gallery']['comment_charset']);
    $text = str_replace(tag('br'), "\r\n", $text);  //save CR LF in comments
    $text = htmlspecialchars($text, ENT_QUOTES, $plugin_cf['gallery']['comment_charset']);

    $t = "<div id=\"gallery_main\">";
    $t .= "<div id=\"gallery_main_inner\">";
    $t .= "<div class=\"thumbnailitem\">";
    if (ereg_i("true", $plugin_cf['gallery']['show_title']) and ereg_i("top", $plugin_cf['gallery']['title_placement']))
        $t .= $title . tag('br');
    $t .= "<a href=\"$sn?$su\" class=\"thumb\">" . tag('img class="picture" src="' . $dir . 'thumb/tn_' . rawurlencode($file) . '" height="' . $h . '" width="' . $w . '" alt="' . $title . '"') . "</a>" . tag('br');
    if (ereg_i("true", $plugin_cf['gallery']['show_title']) and ereg_i("bottom", $plugin_cf['gallery']['title_placement']))
        $t .= $title;
    $token = md5(microtime() . mt_rand());
    $_SESSION['lbg_token'] = $token;
    $t .= "</div>";
    $t .= "<div class=\"addcommentform\">";
    $t .= "<form method=\"post\" action=\"$sn?$su\">";
    $t .= tag('input type="hidden" name="pic" value="' . $pic . '"');
    $t .= tag('input type="hidden" name="page" value="' . $page . '"');
    $t .= tag('input type="hidden" name="action" value="writecomment"');
    $t .= tag('input type="hidden" name="lbg_token" value="' . $token . '"');
    $t .= '<p>' . $plugin_tx['gallery']['form_name'] . tag('br') . tag('input type="text" name="comment_name" size="26" class="gallery_comment_form" value="'.$name.'"') . '</p>';
    $t .= '<p>' . $plugin_tx['gallery']['form_comment'] . tag('br') . '<textarea rows="8" name="comment_text" cols="50" class="gallery_comment_form">'.$text.'</textarea>' . '</p>';
    //HI Start Captcha Code
    $t .= "<p>" . $plugin_tx['gallery']['captcha_heading'] . tag('br') . tag('img id="captcha" src="' . $pth['folder']['plugins'] . 'gallery/securimage/securimage_show.php?sid=' . md5(uniqid(time())) . '" alt="CAPTCHA Image" class="gallery_captcha"') . "&nbsp;&nbsp;" . "</p>";
    $t .= "<p>";
    $t .= $plugin_tx['gallery']['captcha_verify_code'] . "&nbsp;&nbsp;" . tag('input type="text" name="captcha_code" size="10" maxlength="4" class="gallery_comment_form"') . "&nbsp;&nbsp;";
    $t .= "<a class=\"gallery_comment_form\" href=\"#\" onclick=\"document.getElementById('captcha').src = '" . $pth['folder']['plugins'] . "gallery/securimage/securimage_show.php?' + Math.random(); return false\">" . $plugin_tx['gallery']['captcha_reload'] . "</a>";
    $t .= "</p>";
    //HI End Captcha Code
    $t .= "<p>" . tag('input type="submit" value="' . $plugin_tx['gallery']['add_comment_submit'] . '" class="gallery_submit"') . "</p>";
    $t .= "</form></div>";
    $t .= "<div class =\"gallery_clearfix\"></div>";
    $t .= "</div></div>";
    return $t;
}

function popup_java_code() {
    global $plugin_cf, $plugin_tx, $pth;
    $t = '';

    //Advanced user-defined PopUp
    if (ereg_i("true", $plugin_cf['gallery']['adv_popup'])) {
        $gallery_style_url = $pth['folder']['plugins'] . "gallery/css/stylesheet.css";

        $t = '<script type="text/javascript"><!--
            function gallery_fullsize(PIC_URL, width, height, title) {
            width="' . $plugin_cf['gallery']['adv_popup_width'] . '/" ;
            height="' . $plugin_cf['gallery']['adv_popup_height'] . '/" ;
            popup_options="toolbar=0,scrollbars=1,location=0,statusbar=0,menubar=0,resizable=0";
            gallery_popup=window.open("", "", popup_options + ",width=" + width + ",height=" + height);
            gallery_popup.focus();
            gallery_popup.document.open();
            with(gallery_popup) {
            document.write("<html><head>");
            document.write("<title>"+ title +"<\/title>");
            document.write("<link rel=\"stylesheet\" type=\"text/css\" href=\"' . $gallery_style_url . '\">");
            document.write("<\/head>");
            document.write("<BODY scroll=\"auto\" leftmargin=\"0\" marginheight=\"0\" marginwidth=\"0\" topmargin=\"0\">");
            document.write("<div id=\"gallery_adv_popup_outer\"><div id=\"gallery_adv_popup_inner\">");
            document.write("<table width=\"100%\" style=\"height: 100%\" align=\"center\"><tr><td align=\"center\" valign=\"middle\">"); //style="height: 100%
            document.write("<table width=\"100%\" style=\"height: 100%\" align=\"center\"><tr><td align=\"center\" valign=\"middle\">");
            document.write("<img class=\"gallery_adv_popup_img\" border=\"0\" onclick=\"window.close();\" src=\""+ PIC_URL +"\" title=\"' . $plugin_tx['gallery']['close_by_click'] . '\">");
            document.write("<br>");
            document.write("<span class=\"gallery_adv_popup_title\">"+ title +"<\/span>");
            document.write("<\/td><\/tr><\/table>");
            document.write("<\/td><\/tr><\/table>");
            document.write("<\/div><\/div>");
            document.write("<\/BODY><\/html>");
            }
            gallery_popup.document.close();
            }
            //-->
            </script>';
    }
    //The "normal" PopUp
    else {
        $t = '<script type="text/javascript"><!--
            function gallery_fullsize(PIC_URL, width, height, title) {
            popup_options="toolbar=0,scrollbars=1,location=0,statusbar=0,menubar=0,resizable=0";
            gallery_popup=window.open("", "", popup_options + ",width=" + width + ",height=" + height);
            gallery_popup.focus();
            gallery_popup.document.open();
            with(gallery_popup) {
            document.write("<html><head>");
            document.write("<title>"+ title +"<\/title>");
            document.write("<\/head>");
            document.write("<BODY scroll=\"auto\" leftmargin=\"0\" marginheight=\"0\" marginwidth=\"0\" topmargin=\"0\">");
            document.write("<img border=\"0\" onclick=\"window.close();\" src=\""+ PIC_URL +"\" title=\"' . $plugin_tx['gallery']['close_by_click'] . '\">");
            document.write("<\/BODY><\/html>");
            }
            gallery_popup.document.close();
            }
            //-->
            </script>';
    }
    return $t;
}

/*
  function ShowPicture($path, $file, $popup, $title = "No title") {
  global $plugin_cf, $pth, $gallery_rel_attrib;

  //Important! Set default config for e.g. Admin-Mode
  //BadBUG ??? $gallery_conf = isset($_SESSION["gallery_conf"]) ? $gallery_conf : "config";

  $t = '';
  $plugin_include_folder = $pth['folder']['plugins'] . "gallery/includes/";
  $size = GetImageSize($path . $file);
  $width = $size[0];
  $height = $size[1];
  if (!$size) {
  $path = $pth['folder']['plugins'] . "gallery/images/";
  $file = "default_thumb.jpg";
  $width = $plugin_cf['gallery']['thumb_size'];
  $height = $plugin_cf['gallery']['thumb_size'];
  }
  if (($plugin_cf['gallery']['main_max_size'] <= $width) or ($plugin_cf['gallery']['main_max_size'] <= $height)) {
  if ($width >= $height) {
  $x = round($width / $width * $plugin_cf['gallery']['main_max_size']);
  $y = round($height / $width * $plugin_cf['gallery']['main_max_size']);
  }
  if ($height >= $width) {
  $x = round($width / $height * $plugin_cf['gallery']['main_max_size']);
  $y = round($height / $height * $plugin_cf['gallery']['main_max_size']);
  }
  } else {
  $x = $width;
  $y = $height;
  }

  // Modification-HI: Use Lightbox instead of the PopUp-Window if selected in config.php
  // Lightbox with on the fly image
  if (($popup) and (ereg_i("true", $plugin_cf['gallery']['on_the_fly_images'])) and (ereg_i("true", $plugin_cf['gallery']['use_lightbox']))) {
  //echo "Lightbox + on the fly";
  $t .= '<a href="' . $plugin_include_folder . 'image.php?pic=' . base64_encode(realpath($path . $file)) . '&amp;h=' . $height . '&amp;w=' . $width . ',' . $width . ',' . $height . ',' . $title . '" rel="' . $gallery_rel_attrib . '"';
  if (($title != '') and (ereg_i("true", $plugin_cf['gallery']['show_title'])))
  $t .= ' title="' . $title . '"';
  $t .= '>';
  $t .= tag('img src="' . $plugin_include_folder . 'image.php?pic=' . base64_encode(realpath($path . $file)) . '&amp;h=' . $y . '&amp;w=' . $x . '" height="' . $y . '" width="' . $x . '" alt="' . $title . '" class="picture"') . "</a>";
  }

  // PopUp with on the fly image
  elseif (($popup) and (ereg_i("true", $plugin_cf['gallery']['on_the_fly_images']))) {
  //echo "PopUp + on the fly";
  $t .= "<a href=\"javascript:gallery_fullsize('" . $plugin_include_folder . "image.php?pic=" . base64_encode(realpath($path . $file)) . "&amp;h=" . $height . "&amp;w=" . $width . "','" . $width . "','" . $height . "','" . $title . "');\">";
  $t .= tag('img src="' . $plugin_include_folder . 'image.php?pic=' . base64_encode(realpath($path . $file)) . '&amp;h=' . $y . '&amp;w=' . $x . '" height="' . $y . '" width="' . $x . '" alt="' . $title . '" class="picture"') . "</a>";
  }

  // Lightbox with normal image
  elseif (($popup) and (ereg_i("true", $plugin_cf['gallery']['use_lightbox']))) {
  //echo "Lightbox";
  $t .= '<a href="./' . $path . $file . '" rel="' . $gallery_rel_attrib . '"';
  if (($title != '') and (ereg_i("true", $plugin_cf['gallery']['show_title'])))
  $t .= ' title="' . $title . '"';
  $t .= '>';
  $t .= tag('img src="' . $path . $file . '" height="' . $y . '" width="' . $x . '" alt="' . $title . '" class="picture"') . "</a>";
  }

  // The normal PopUp
  else {
  if ($popup)
  $t .= "<a href=\"javascript:gallery_fullsize('" . $path . str_replace("'", "\'", $file) . "','" . $width . "','" . $height . "','" . $title . "');\">";
  $t .= tag('img src="' . $path . $file . '" height="' . $y . '" width="' . $x . '" alt="' . $title . '" class="picture"') . "</a>";
  }

  return $t;
  }
  //end of function ShowPicture

  //HI ShowFromThumb: To get a Lightbox-Picture-Set or PopUp direct from the thumb-view
  function ShowFromThumb($path, $file, $title = "No title") {
  global $plugin_cf, $pth, $gallery_rel_attrib;
  $t = '';
  $plugin_include_folder = $pth['folder']['plugins'] . "gallery/includes/";
  $size = GetImageSize($path . $file);
  $width = $size[0];
  $height = $size[1];
  if (!$size) {
  $path = $pth['folder']['plugins'] . "gallery/images/";
  $file = "default_thumb.jpg";
  $width = "125";
  $height = "125";
  }
  if (($plugin_cf['gallery']['main_max_size'] <= $width) or ($plugin_cf['gallery']['main_max_size'] <= $height)) {
  if ($width >= $height) {
  $x = round($width / $width * $plugin_cf['gallery']['main_max_size']);
  $y = round($height / $width * $plugin_cf['gallery']['main_max_size']);
  }
  if ($height >= $width) {
  $x = round($width / $height * $plugin_cf['gallery']['main_max_size']);
  $y = round($height / $height * $plugin_cf['gallery']['main_max_size']);
  }
  } else {
  $x = $width;
  $y = $height;
  }


  // Lightbox with on the fly image
  if ((ereg_i("true", $plugin_cf['gallery']['on_the_fly_images'])) and (ereg_i("true", $plugin_cf['gallery']['use_lightbox']))) {
  //echo "Lightbox + on the fly + ShowFromThumb";
  $t .= '<a href="' . $plugin_include_folder . 'image.php?pic=' . base64_encode(realpath($path . $file)) . '&amp;h=' . $height . '&amp;w=' . $width . ',' . $width . ',' . $height . ',' . $title . '" rel="' . $gallery_rel_attrib . '"';
  if (($title != '') and (ereg_i("true", $plugin_cf['gallery']['show_title'])))
  $t .= ' title="' . $title . '"';
  $t .= '>';
  }

  // PopUp with on the fly image
  if ((ereg_i("true", $plugin_cf['gallery']['on_the_fly_images'])) and (ereg_i("false", $plugin_cf['gallery']['use_lightbox']))) {
  //echo "PopUp + on the fly + ShowFromThumb";
  $t .= "<a href=\"javascript:gallery_fullsize('" . $plugin_include_folder . "image.php?pic=" . base64_encode(realpath($path . $file)) . "&amp;h=" . $height . "&amp;w=" . $width . "','" . $width . "','" . $height . "','" . $title . "');\">";
  }

  // Lightbox with normal image
  if ((ereg_i("false", $plugin_cf['gallery']['on_the_fly_images'])) and (ereg_i("true", $plugin_cf['gallery']['use_lightbox']))) {
  //echo "Lightbox with normal picture + ShowFromThumb";
  $t .= '<a href="./' . $path . $file . '" rel="' . $gallery_rel_attrib . '"';
  if (($title != '') and (ereg_i("true", $plugin_cf['gallery']['show_title'])))
  $t .= ' title="' . $title . '"';
  $t .= '>';
  }

  // PopUp with with normal image
  if ((ereg_i("false", $plugin_cf['gallery']['on_the_fly_images'])) and (ereg_i("false", $plugin_cf['gallery']['use_lightbox']))) {
  //echo "PopUp with normal image";
  $t .= "<a href=\"javascript:gallery_fullsize('" . $path . str_replace("'", "\'", $file) . "','" . $width . "','" . $height . "','" . $title . "');\">";
  }

  return $t;
  }

  //end of function ShowFromThumb
 */

function ShowPicture($path, $file, $popup, $title = "No title") {
    global $plugin_cf, $pth, $gallery_rel_attrib;

    $t = '';
    $plugin_include_folder = $pth['folder']['plugins'] . "gallery/includes/";
    $size = GetImageSize($path . $file);
    $width = $size[0];
    $height = $size[1];
    if (!$size) {
        $path = $pth['folder']['plugins'] . "gallery/images/";
        $file = "default_thumb.jpg";
        $width = "125";
        $height = "125";
    }
    if (($plugin_cf['gallery']['main_max_size'] <= $width) or ($plugin_cf['gallery']['main_max_size'] <= $height)) {
        if ($width >= $height) {
            $x = round($width / $width * $plugin_cf['gallery']['main_max_size']);
            $y = round($height / $width * $plugin_cf['gallery']['main_max_size']);
        }
        if ($height >= $width) {
            $x = round($width / $height * $plugin_cf['gallery']['main_max_size']);
            $y = round($height / $height * $plugin_cf['gallery']['main_max_size']);
        }
    } else {
        $x = $width;
        $y = $height;
    }

    // Modification-HI: Use Lightbox instead of the PopUp-Window if selected in config.php
    // Lightbox with on the fly image
    if (($popup) and (ereg_i("true", $plugin_cf['gallery']['on_the_fly_images'])) and (ereg_i("true", $plugin_cf['gallery']['use_lightbox']))) {
        //echo "Lightbox + on the fly";
        $t .= '<a href="' . $plugin_include_folder . 'image.php?pic=' . base64_encode(realpath($path . $file)) . '&amp;h=' . $height . '&amp;w=' . $width . ',' . $width . ',' . $height . ',' . $title . '" rel="' . $gallery_rel_attrib . '"';
        if (ereg_i("true", $plugin_cf['gallery']['show_html_title'])) {
            $t .= " title='" . lb_htmlTitles($path, $file) . "'";
        } else {
            $t .= " title='" . $title . "'";
        }
        $t .= '>';
    }

    // PopUp with on the fly image
    elseif (($popup) and (ereg_i("true", $plugin_cf['gallery']['on_the_fly_images']))) {
        //echo "PopUp + on the fly";
        $t .= "<a href=\"javascript:gallery_fullsize('" . $plugin_include_folder . "image.php?pic=" . base64_encode(realpath($path . $file)) . "&amp;h=" . $height . "&amp;w=" . $width . "','" . $width . "','" . $height . "','" . $title . "');\">";
    }

    // Lightbox with normal image
    elseif (($popup) and (ereg_i("true", $plugin_cf['gallery']['use_lightbox']))) {
        //echo "Lightbox";
        $t .= '<a href="./' . $path . $file . '" rel="' . $gallery_rel_attrib . '"';
        if (ereg_i("true", $plugin_cf['gallery']['show_html_title'])) {
            $t .= " title='" . lb_htmlTitles($path, $file) . "'";
        } else {
            $t .= " title='" . $title . "'";
        }
        $t .= '>';
    }

    // The normal PopUp
    else {
        if ($popup)
            $t .= "<a href=\"javascript:gallery_fullsize('" . $path . str_replace("'", "\'", $file) . "','" . $width . "','" . $height . "','" . $title . "');\">";
    }

    if (ereg_i("true", $plugin_cf['gallery']['on_the_fly_images']) && !ereg_i("thumb\/tn_", $path . $file)) {
        $t .= tag('img src="' . $plugin_include_folder . 'image.php?pic=' . base64_encode(realpath($path . $file)) . '&amp;h=' . $y . '&amp;w=' . $x . '" height="' . $y . '" width="' . $x . '" title="' . $title . '" alt="' . $title . '" class="picture"') . "</a>";
    } else {
        $t .= tag('img src="' . $path . $file . '" height="' . $y . '" width="' . $x . '" title="' . $title . '" alt="' . $title . '" class="picture"') . "</a>";
    }

    return $t;
}

//ShowFromThumb: To get a Lightbox-Picture-Set or PopUp direct from the thumb-view
function ShowFromThumb($path, $file, $title = "No title") {
    global $plugin_cf, $pth, $gallery_rel_attrib;
    $t = '';
    $plugin_include_folder = $pth['folder']['plugins'] . "gallery/includes/";
    $size = GetImageSize($path . $file);
    $width = $size[0];
    $height = $size[1];
    if (!$size) {
        $path = $pth['folder']['plugins'] . "gallery/images/";
        $file = "default_thumb.jpg";
        $width = "125";
        $height = "125";
    }
    if (($plugin_cf['gallery']['main_max_size'] <= $width) or ($plugin_cf['gallery']['main_max_size'] <= $height)) {
        if ($width >= $height) {
            $x = round($width / $width * $plugin_cf['gallery']['main_max_size']);
            $y = round($height / $width * $plugin_cf['gallery']['main_max_size']);
        }
        if ($height >= $width) {
            $x = round($width / $height * $plugin_cf['gallery']['main_max_size']);
            $y = round($height / $height * $plugin_cf['gallery']['main_max_size']);
        }
    } else {
        $x = $width;
        $y = $height;
    }


    // Lightbox with on the fly image
    if ((ereg_i("true", $plugin_cf['gallery']['on_the_fly_images'])) and (ereg_i("true", $plugin_cf['gallery']['use_lightbox']))) {
        //echo "Lightbox + on the fly + ShowFromThumb";
        $t .= '<a href="' . $plugin_include_folder . 'image.php?pic=' . base64_encode(realpath($path . $file)) . '&amp;h=' . $height . '&amp;w=' . $width . ',' . $width . ',' . $height . ',' . $title . '" rel="' . $gallery_rel_attrib . '"';
        if (ereg_i("true", $plugin_cf['gallery']['show_html_title'])) {
            $t .= " title='" . lb_htmlTitles($path, $file) . "'";
        } else {
            $t .= " title='" . $title . "'";
        }
        $t .= '>';
    }

    // PopUp with on the fly image
    if ((ereg_i("true", $plugin_cf['gallery']['on_the_fly_images'])) and (ereg_i("false", $plugin_cf['gallery']['use_lightbox']))) {
        //echo "PopUp + on the fly + ShowFromThumb";
        $t .= "<a href=\"javascript:gallery_fullsize('" . $plugin_include_folder . "image.php?pic=" . base64_encode(realpath($path . $file)) . "&amp;h=" . $height . "&amp;w=" . $width . "','" . $width . "','" . $height . "','" . $title . "');\">";
    }

    // Lightbox with normal image
    if ((ereg_i("false", $plugin_cf['gallery']['on_the_fly_images'])) and (ereg_i("true", $plugin_cf['gallery']['use_lightbox']))) {
        //echo "Lightbox with normal picture + ShowFromThumb";
        $t .= '<a href="./' . $path . $file . '" rel="' . $gallery_rel_attrib . '"';
        if (ereg_i("true", $plugin_cf['gallery']['show_html_title'])) {
            $t .= " title='" . lb_htmlTitles($path, $file) . "'";
        } else {
            $t .= " title='" . $title . "'";
        }
        $t .= '>';
    }

    // PopUp with with normal image
    if ((ereg_i("false", $plugin_cf['gallery']['on_the_fly_images'])) and (ereg_i("false", $plugin_cf['gallery']['use_lightbox']))) {
        $t .= "<a href=\"javascript:gallery_fullsize('" . $path . str_replace("'", "\'", $file) . "','" . $width . "','" . $height . "','" . $title . "');\">";
    }

    return $t;
}

//end of function ShowFromThumb

function lb_htmlTitles($path, $file) {

    global $plugin_cf;

    $html_content = '';

    if (ereg_i("true", $plugin_cf['gallery']['include_external_htmlfile'])) {
        $htmlfilename = filename_for_html($path . $file);
        if (is_readable($htmlfilename)) {
            $html_content = file_get_contents($htmlfilename);
        }
    }
    return $html_content;
}

function WriteImagesList($dir, $data_array) {
    global $o;
    $data = '';

    if (!empty($data_array)) {
        foreach ($data_array as $value) {
            $data .= $value . ';';
        }
        $data = substr($data, 0, -1);
    }
    $handle = fopen($dir . "images.list", "w");
    fwrite($handle, $data);
    fclose($handle);
    if (!is_writable($dir . "images.list")) {
        $o .= "Warning : " . $dir . "images.list is not writable. Please change permissions<br>";
        return false;
    }
    return true;
}

function ReadImagesList($dir) {
    global $o;
    $data = '';
    $images_array = array();

    if (!is_readable($dir . "images.list")) {
        $o .= "Warning : unable to read " . $dir . "images.list Please change permissions<br>";
        return false;
    }
    $data = file_get_contents($dir . "images.list");
    $images_array = explode(';', $data);

    return $images_array;
}

function UpdateImagesList($files_array, $imagelist_array) {
    //vergleicht Dateien im Bilder-Ordner mit Einträgen in images.list
    //return: UpToDate Array mit allen Bildnamen

    if (count($files_array) > count($imagelist_array)) {
        //neue Files vorhanden
        $result = array_diff($files_array, $imagelist_array);
        return array_merge($imagelist_array, $result);
    } else {
        //Files gelöscht?
        $diff = array_diff($imagelist_array, $files_array);
        return array_diff($imagelist_array, $diff);
    }
}

function LoadFilesArray($dir) {

    $files_array = array();
    if ($handle = @opendir($dir)) {
        while (false !== ($file = readdir($handle))) {
            if (ereg_i(".jpg", $file)) {
                array_push($files_array, $file);
            }
        }
        closedir($handle);
        sort($files_array);
    }

    //if(!file_exists($dir . 'images.list')) {
    //on first run better this way:
    if (count($files_array) <= 1) {
        WriteImagesList($dir, $files_array);
        return $files_array;
    } else {
        $imagelist_array = ReadImagesList($dir);
        if (count($files_array) == count($imagelist_array)) {
            return $imagelist_array;
        } else {
            //Update
            $imagelist_array = UpdateImagesList($files_array, $imagelist_array);
            WriteImagesList($dir, $imagelist_array);
            return $imagelist_array;
        }
    }
}

function filename_for_comments($file) {
    global $plugin_cf, $cf, $sl;
    $t = '';
    if (ereg_i("true", $plugin_cf['gallery']['multilanguage_comments'])) {
        if ($sl != $cf['language']['default']) {
            $t = preg_replace("/.jpg/i", "-" . $sl . "-text.txt", $file);
        }
        else
            $t = preg_replace("/.jpg/i", "-text.txt", $file);
    }
    else
        $t = preg_replace("/.jpg/i", "-text.txt", $file);
    return $t;
}

function CreateImagetxtFile($dir, $file) {
    global $plugin_cf;
    $filename = filename_for_comments($file);
    $filetitle = $file;
    switch (strtolower($plugin_cf['gallery']['title_default'])) {
        case 'name':
            $filetitle = preg_replace("/.jpg/i", "", $file);
            break;
        case 'filename':
            $filetitle = $file;
            break;
        case '':
            $filetitle = '';
            break;
        default:
            $filetitle = $plugin_cf['gallery']['title_default'];
            break;
    }
    if (!file_exists($dir . $filename)) {
        $handle = fopen($dir . $filename, 'w+');
        fwrite($handle, $filetitle . $plugin_cf['gallery']['delimiter']);
        fclose($handle);
    }
    if (!is_writable($dir . $filename))
        $t .= 'Warning : '.$dir.$filename.' is not writable please change permissions'.tag('br');
    else
        $t = '';
    return $t;
}

function filename_for_html($file) {
    global $plugin_cf, $cf, $sl;
    $t = '';
    if (ereg_i("true", $plugin_cf['gallery']['multilanguage_html-file'])) {
        if ($sl != $cf['language']['default']) {
            $t = preg_replace("/.jpg/i", "-" . $sl . "-html.html", $file);
        }
        else
            $t = preg_replace("/.jpg/i", "-html.html", $file);
    }
    else
        $t = preg_replace("/.jpg/i", "-html.html", $file);
    return $t;
}

function CreateImageHtmlFile($dir, $file) {
    global $plugin_cf;
    $filename = filename_for_html($file);
    if (!file_exists("$dir" . "$filename")) {
        $handle = fopen("$dir" . "$filename", "w+");
        fclose($handle);
    }
    if (!is_writable($dir . $filename))
        $t .= "Warning : $dir$filename is not writable. Please change permissions<br>";
    else
        $t = '';
    return $t;
}

function filename_for_desc() {
    global $plugin_cf, $cf, $sl;
    $t = '';
    if (ereg_i("true", $plugin_cf['gallery']['multilanguage_desc-file'])) {
        if ($sl != $cf['language']['default']) {
            $t = 'gallery-' . $sl . '-desc.html';
        }
        else
            $t = 'gallery-desc.html';
    }
    return $t;
}

function CreateDescFile($dir, $filename) {
    $filename = filename_for_desc();
    if (!file_exists($dir . $filename)) {
        $handle = fopen($dir . $filename, "w+");
        fclose($handle);
    }
    if (!is_writable($dir . $filename))
        $t .= "Warning : $dir$filename is not writable. Please change permissions<br>";
    else
        $t = '';
    return $t;
}

function getvariable($variable) {
    $t = isset($_GET[$variable]) ? $_GET[$variable] : '';
    $t .= isset($_POST[$variable]) ? $_POST[$variable] : '';
    return $t;
}

function unlinkRecursive($dir, $deleteRootToo) {
    if (!$dh = @opendir($dir)) {
        return false;
    }
    while (false !== ($obj = readdir($dh))) {
        if ($obj == '.' || $obj == '..') {
            continue;
        }
        if (!@unlink($dir . '/' . $obj)) {
            unlinkRecursive($dir . '/' . $obj, true);
        }
    }
    closedir($dh);
    if ($deleteRootToo) {
        @rmdir($dir) or die($dir . ' couldn\'t be deleted!');
    }
    return true;
}

function Show_Script_Version($ScriptFile) {
    $t = '';
    $buffer = file_get_contents($ScriptFile);
    $match = '';

    if (preg_match("#\@Version: (.*?)\@#", $buffer, $match))
        $t = $match[1] . ", ";
    if (preg_match("#\@Date: (.*?)\@#", $buffer, $match))
        $t .= $match[1];
    $t .= tag('br');
    return $t;
}

//Test
function resize_pic($pic) {
    global $plugin_cf;
    $error = 26;

    $resize_w = 0;
    $resize_h = 0;
    $size = GetImageSize($pic);
    if (!$size) {
        //$t .= tag('br')."Gallery Error : Unable to get imagesize of ".$pic;
        //return $t;
        $error = 25;
        return $error;
        exit;
    }
    $width = $size[0];
    $height = $size[1];
    $qual = $plugin_cf['gallery']['resize_quality'];
    $resmax = $plugin_cf['gallery']['resize_max'];
    if (($width >= $height) && ($width > $plugin_cf['gallery']['resize_max'])) { //landscape or quadrate
        $resize_w = $plugin_cf['gallery']['resize_max'];
        $resize_h = $height / $width * $plugin_cf['gallery']['resize_max'];
    }
    if (($height > $width) && ($height > $plugin_cf['gallery']['resize_max'])) { //portrait
        $resize_h = $plugin_cf['gallery']['resize_max'];
        $resize_w = $width / $height * $plugin_cf['gallery']['resize_max'];
    }
    if (($resize_w > 0) && ($resize_h > 0)) {
        $bigpic = imagecreatefromjpeg($pic) or die("Gallery Error : Picture is too big " . $pic . " (" . $width . "x" . $height . ") resize it to something smaller");
        $smallpic = imageCreateTrueColor($resize_w, $resize_h);
        if (!$smallpic) {
            $smallpic = imageCreate($resize_w, $resize_h);
            ImageCopyResized($smallpic, $bigpic, 0, 0, 0, 0, $resize_w, $resize_h, $width, $height);
        } else {
            imagecopyresampled($smallpic, $bigpic, 0, 0, 0, 0, $resize_w, $resize_h, $width, $height);
        }
        ImageJPEG($smallpic, $pic, $qual);
        ImageDestroy($smallpic);
        ImageDestroy($bigpic);
        $error = 24;
    }
    return $error;
}

function lbg_clearNames($direction = '', $file = '') {
//    jQuery-Sorter has problems with some characters...
//    This function replaces and restores them

    if ($direction == '' || $file == '') {
        return FALSE;
    }
    $org = '_,-';
    $new = '$$a$$,$$b$$';

    switch ($direction) {
        case 'new':
            $file = str_replace(explode(",", $org), explode(",", $new), $file);
            return $file;
            break;

        case 'org':
            $file = str_replace(explode(",", $new), explode(",", $org), $file);
            return $file;
            break;

        default:
            return FALSE;
            break;
    }
}

//from php.net
//http://www.php.net/manual/en/function.array-keys.php#107855

if (!function_exists('normalize_array')) {

    function normalize_array($array) {
        $newarray = array();
        $array_keys = array_keys($array);
        $i = 0;
        foreach ($array_keys as $key) {
            $newarray[$i] = $array[$key];

            $i++;
        }
        return $newarray;
    }

}

function lbgIcon($img = '') {
    global $pth, $plugin;
    $lbgImgFolder = $pth['folder']['plugins'] . $plugin . "/images/";
    return tag('img src=' . $lbgImgFolder . $img);
}

if (!function_exists('ereg_i')) {

    function ereg_i($search = '', $confVar = '') {
        if (preg_match("/$search/i", $confVar)) {
            return true;
        } else {
            return false;
        }
    }

}

function lbgSpecialChars($string = '') {
    global $plugin_cf;

    $string = html_entity_decode($string, ENT_QUOTES, $plugin_cf['gallery']['comment_charset']);
    $string = htmlspecialchars(strip_tags($string), ENT_QUOTES, $plugin_cf['gallery']['comment_charset']);
    //$string = str_replace($plugin_cf['gallery']['delimiter'], htmlentities($plugin_cf['gallery']['delimiter'], ENT_QUOTES, $plugin_cf['gallery']['comment_charset']), $string);
    $string = str_replace($plugin_cf['gallery']['delimiter'], '_', $string); //remove delimiter
    return $string;
}

function lbgConfig($dir = FALSE) {
    global $pth, $hjs, $plugin_cf;

    $config = $dir . 'config.php';
    $css = $dir . 'stylesheet.css';
    $_SESSION['lbg_config'] = '../config/config.php'; //relativ zu image.php

    /*
     * copy-version is deprecated
     * 
      //load defaults
      @include_once $pth['folder']['plugins'] . 'gallery/config/defaultconfig.php';

      if (!file_exists($config)) {
      copy($pth['folder']['plugins'] . 'gallery/config/config.php', $config) OR die('Can\'t copy Gallery-Configuration');
      }

      if (!file_exists($css)) {
      copy($pth['folder']['plugins'] . 'gallery/css/stylesheet.css', $css) OR die('Can\'t copy Gallery-Stylesheet');
      }

      //css überschreiben
      $hjs .= "\n" . tag('link rel="stylesheet" href="' . $css . '" type="text/css"');
      //config laden
      if (include $config) {
      $configpath = str_replace('../', '', $config);
      $configpath = str_replace('./', '', $configpath);
      $configpath = '../../../' . $configpath;
      $_SESSION['lbg_config'] = $configpath;
      }
     */
    if (is_readable($config)) {
        //load defaults
        @include $pth['folder']['plugins'] . 'gallery/config/defaultconfig.php';
        //overwrite with local config
        if ((include $config) === 1) {
            $configpath = str_replace('../', '', $config);
            $configpath = str_replace('./', '', $configpath);
            $configpath = '../../../' . $configpath;
            $_SESSION['lbg_config'] = $configpath;
        }
    }
    if (is_readable($css)) {
        //overwrite default css
        $hjs .= "\n" . tag('link rel="stylesheet" href="' . $css . '" type="text/css"');
    }
}

/*
function lbg_admin_common($path, $action, $admin, $plugin, $hint = ARRAY()) {

    global $sn, $pth, $tx;
    global $pluginloader_tx, $plugin_tx, $plugin_cf;
    $data = '';
    $t = '';

    if ($admin == 'lb_plugin_config') {
        $var_name = 'plugin_cf';
        $data = $plugin_cf[$plugin];
        $file = 'config.php';
    }
    if ($admin == 'lb_plugin_stylesheet') {
        $var_name = 'plugin_text';
        $file = 'stylesheet.css';
    }

    if ($path != '') {
        $_SESSION['lbg_admin_path'] = $path;
    } else {
        $path = $_SESSION['lbg_admin_path'];
    }
    $filename = $path . $file;
    $error_msg = ($admin == '' OR is_writeable($filename)) ? '' : '<div class="pluginerror">' . "\n" . '<b>' . $tx['error']['notwritable'] . ':</b>' . "\n" . '</div>' . "\n" . '<ul>' . "\n" . '<li>' . $filename . '</li>' . "\n" . '</ul>' . "\n";

    var_dump($_SESSION['lbg_admin_path']);
    var_dump($filename);
    if ($action == 'plugin_text' OR $action == 'plugin_edit') {
        if (isset($plugin_tx[$plugin])) {
            $hint = array_merge($hint, $plugin_tx[$plugin]);
        }
        $form = ARRAY();
        $style = ARRAY();

        $style['form'] = 'class="plugineditform"';
        $style['divcaption'] = 'class="plugineditcaption"';
        $style['submit'] = 'class="submit"';

        $form['action'] = $sn . '?&amp;' . $plugin;
        $form['method'] = 'POST';
        $form['value_admin'] = $admin;
        $form['value_submit'] = ucfirst($tx['action']['save']);
        $form['caption'] = ucfirst(str_replace("_", " ", $plugin));
        $form['errormsg'] = $error_msg;

        if ($action == 'plugin_text') {
            $file_data = PluginReadFile($filename);
            $data = $file_data['content'];
            $form['type'] = 'TEXT';
            $form['value_action'] = 'plugin_textsave';
            $form['textarea_name'] = 'plugin_text';
            $style['div'] = 'class="plugintext"';
            $style['textarea'] = 'class="plugintextarea"';
        }
        if ($action == 'plugin_edit') {
            $form['type'] = 'CONFIG';
            $form['value_action'] = 'plugin_save';
            $style['div'] = 'class="pluginedit"';
            $style['table'] = 'class="pluginedittable"';
            $style['tdcaption'] = 'class="plugincfcap"';
            $style['tdhint'] = 'class="plugincfhint"';
            $style['tdconfig'] = 'class="plugincf"';
            $style['input'] = 'class="plugininput"';
            $style['inputmax'] = 'class="plugininputmax"';
        }
        $t .= PluginSaveForm($form, $style, $data, $hint);
    }

    if ($action == 'plugin_save' OR $action == 'plugin_textsave') {
        if ($action == 'plugin_save') {
            $config_data = ARRAY();
            foreach ($data as $key => $value) {
                global $pluginloader_cfg;
                $config_data[$key] = $_POST[$pluginloader_cfg['form_namespace'] . $key];
            }
            $save_data = PluginPrepareConfigData($var_name, $config_data, $plugin);
        }
        if ($action == 'plugin_textsave') {
            $text_data = $_POST[$var_name];
            $save_data = PluginPrepareTextData($text_data);
        }

        $is_saved = PluginWriteFile($filename, $save_data);
        $t .= tag('br') . '<b>' . $is_saved['msg'] . '</b>' . tag('br');
        unset($_SESSION['lbg_admin_path']);
    }

    $t .= tag('br');
    $t.= '<div class="lb_buttons">';
    $t .= '<button type="submit" style="regular" onClick="location.href=\'?&gallery&admin=plugin_main&path=' . $path . '&action=view\'">' . lbgIcon('arrow_left_16.png') . ' ' . $plugin_tx['gallery']['admin_sort_ok'] . '</button>';
    $t .= '</div>';
    $t .= tag('br style="clear: left;"');

    return $t;
}
*/